---------------------------------------

tail = 0

mono_stereo_multichan = 2

prefader_postfader = 0

time_selection = 1

mute_disabel_delete = 0

include_fx = 1

  copy_fx = 1
  copy_fx_envelopes = 1
  
include_sends = 1

pre_render_length = 0
   
   trim_start = 1


---------------------------------------

local values_for_render = tostring(tail)
..","..tostring(mono_stereo_multichan)
..","..tostring(prefader_postfader)
..","..tostring(time_selection)
..","..tostring(mute_disabel_delete)
..","..tostring(include_fx)
..","..tostring(copy_fx)
..","..tostring(copy_fx_envelopes)
..","..tostring(include_sends)
..","..tostring(pre_render_length)
..","..tostring(trim_start)


---Test----

function OpenURL(url)
  local OS = reaper.GetOS()
  if OS == "OSX32" or OS == "OSX64" then
    os.execute('open "" "' .. url .. '"')
  else
    os.execute('start "" "' .. url .. '"')
  end
end
      
      
local test = reaper.NF_GetMediaItemPeakRMS_Windowed --function added in 2.9.7 SWS
if not test then 
window = reaper.MB('Please install or udpate SWS extension', 'Error', 0) end
if window  then
OpenURL("http://www.sws-extension.org/") return
end


if reaper.CountSelectedMediaItems(0) == 0 then reaper.MB('Please select an item', 'Error', 0) return end


-----Thanks MPL-----Various functions for save/restore bypass state of FX----

local function SetStrState()
    local str = ''
    for i = 1, reaper.CountTracks(0) do
      local tr = reaper.GetTrack(0,i-1)
      str = str..'bypass_states '..reaper.GetTrackGUID(tr)
      for fx = 1,  reaper.TrackFX_GetCount( tr ) do
        local state = reaper.TrackFX_GetEnabled( tr, fx-1 )
        if state == false then 
          str = str..' '..(fx-1)
        end
      end
      str = str ..'\n'
    end
    reaper.SetProjExtState( 0, 'MPL_BYPASSFX', 'state', str )
  end

local function GetStrState()
    local t = {}
    local retval, str = reaper.GetProjExtState( 0, 'MPL_BYPASSFX', 'state' )
    if retval ~= 1 or str == '' then return end
    for line in str:gmatch('[^\r\n]+') do 
      if line:match('bypass_states') then 
        local GUID = line:match('%{.-%}')
        if GUID then 
          t[GUID]= {}
          for dig in line:gmatch('%s[%d]+') do if tonumber(dig) then  t[GUID][tonumber(dig)+1] = 1 end end
        end
      end 
    end
    return t
  end

local function IsInstrument(track, fx)  return  reaper.TrackFX_GetInstrument( track ) == fx end

---Save FX bypass for selected tracks----

local function SetFXState_save(FX_state, t)
    for i = 1, reaper.CountSelectedTracks(0) do
      local tr = reaper.GetSelectedTrack(0,i-1)
      local GUID = reaper.GetTrackGUID(tr)
      for fx_id = 1, reaper.TrackFX_GetCount(tr) do
        local retval, midi = reaper.TrackFX_GetFXName(tr, fx_id-1, 0)
        if not IsInstrument(tr, fx_id-1) and midi ~= 'VST: ReaControlMIDI (Cockos)' and midi ~= 'VST3: Melodyne (Celemony)' then
          -- check t
          if FX_state == true then 
            if not (t[GUID] and t[GUID][fx_id]) then
              reaper.TrackFX_SetEnabled(tr, fx_id-1, FX_state)
            end
           else 
            reaper.TrackFX_SetEnabled(tr, fx_id-1, FX_state)
          end
        end
      end
    end
  end

---Restore FX bypass for the following tracks after the selected tracks (after render)---

local function SetFXState_restore(FX_state, t)
    for i = 1, reaper.CountSelectedTracks(0) do
      local tr = reaper.GetSelectedTrack(0,i-1)
      local num = reaper.GetMediaTrackInfo_Value(tr, 'IP_TRACKNUMBER')
      local get_tr = reaper.GetTrack(0, num)
      if get_tr then
        local GUID = reaper.GetTrackGUID(get_tr)
        for fx_id = 1, reaper.TrackFX_GetCount(get_tr) do
          local retval, midi = reaper.TrackFX_GetFXName(get_tr, fx_id-1, 0)
          if not IsInstrument(get_tr, fx_id-1) and midi ~= 'VST: ReaControlMIDI (Cockos)' and midi ~= 'VST3: Melodyne (Celemony)' then
            -- check t
            if FX_state == true then 
              if not (t[GUID] and t[GUID][fx_id]) then
               reaper.TrackFX_SetEnabled(get_tr, fx_id-1, FX_state)
              end
            else 
              reaper.TrackFX_SetEnabled(get_tr, fx_id-1, FX_state)
            end
         end
        end
      end
    end
end

---Restore FX bypass for the selected tracks, if render is canceled---

local function SetFXState_restore_2(FX_state, t)
    for i = 1, reaper.CountSelectedTracks(0) do
      local tr = reaper.GetSelectedTrack(0,i-1)
      if tr then
        local GUID = reaper.GetTrackGUID(tr)
        for fx_id = 1, reaper.TrackFX_GetCount(tr) do
          local retval, midi = reaper.TrackFX_GetFXName(tr, fx_id-1, 0)
          if not IsInstrument(tr, fx_id-1) and midi ~= 'VST: ReaControlMIDI (Cockos)' and midi ~= 'VST3: Melodyne (Celemony)' then
            -- check t
            if FX_state == true then 
              if not (t[GUID] and t[GUID][fx_id]) then
               reaper.TrackFX_SetEnabled(tr, fx_id-1, FX_state)
              end
            else 
              reaper.TrackFX_SetEnabled(tr, fx_id-1, FX_state)
            end
         end
        end
      end
    end
end



----Thanks me2beats----Copy fx with automations----

local function nothing() end; local function bla() reaper.defer(nothing) end
    
function GetTrackChunk(track)
      if not track then return end
      local fast_str, track_chunk
      fast_str = reaper.SNM_CreateFastString("")
      if reaper.SNM_GetSetObjectState(track, fast_str, false, false) then
        track_chunk = reaper.SNM_GetFastString(fast_str)
      end
      reaper.SNM_DeleteFastString(fast_str)  
      return track_chunk
end
    
function SetTrackChunk(track, track_chunk)
      if not (track and track_chunk) then return end
      local fast_str, ret 
      fast_str = reaper.SNM_CreateFastString("")
      if reaper.SNM_SetFastString(fast_str, track_chunk) then
        ret = reaper.SNM_GetSetObjectState(track, fast_str, true, false)
      end
      reaper.SNM_DeleteFastString(fast_str)
      return ret 
end
    
function esc_lite (str) str = str:gsub('%-', '%%-') return str end
    
    
function Elem_in_tb(elem,tb)
    -- element shouldn't be tb
      _found = nil
      for eit = 1, #tb do if tb[eit] == elem then _found = 1 break end end
      if not _found then return false else _found = nil return true end
end
    
    
function Gen_Guid(guid)
      new_guid = reaper.genGuid()
      if Elem_in_tb(new_guid,guids_tb) == false then
        gsub_tb[guid] = new_guid
        guids_tb[#guids_tb+1] = new_guid
        return
      else Gen_Guid() end
end
    
    
function New_guids(str)
    
      guids_tb = {}
    
      for i = 0, reaper.CountTracks()-1 do
        tr = reaper.GetTrack(0,i)
      chunk = GetTrackChunk(tr)
        for guid in chunk:gmatch'{........%-....%-....%-....%-............}' do
          if Elem_in_tb(guid,guids_tb) == false then
            table.insert(guids_tb, guid)
          end
        end
      end
    
      gsub_tb = {}
      for guid in str:gmatch'{........%-....%-....%-....%-............}' do
        Gen_Guid(guid)
      end
    
      for k,v in pairs(gsub_tb) do str = str:gsub(esc_lite(k),v) end
      
      return str
    
end
    
    
function esc (str)
    str = str:gsub('%(', '%%(')
    str = str:gsub('%)', '%%)')
    str = str:gsub('%.', '%%.')
    str = str:gsub('%+', '%%+')
    str = str:gsub('%-', '%%-')
    str = str:gsub('%$', '%%$')
    str = str:gsub('%[', '%%[')
    str = str:gsub('%]', '%%]')
    str = str:gsub('%*', '%%*')
    str = str:gsub('%?', '%%?')
    str = str:gsub('%^', '%%^')
    str = str:gsub('/', '%%/')
return str end
    
    
local function copy_fx_with_automations()
    
    tracks = reaper.CountSelectedTracks()
    
    -- clear empty FX chain, because bug, when first pasting FX chain to new track
    reaper.Main_OnCommand(reaper.NamedCommandLookup("_S&M_CLRFXCHAIN3"), 0)
    
    
        for j=0, tracks-1 do
        tr_to = reaper.GetSelectedTrack(0,j)
        get_tr = reaper.GetMediaTrackInfo_Value(tr_to, 'IP_TRACKNUMBER')
        tr_from = reaper.GetTrack(0, get_tr)
        get_count = reaper.TrackFX_GetCount(tr_from)
        
        for i=0, get_count-1 do
    
           --reaper.GetTrack(0,get_tr)
          chunk_from = GetTrackChunk(tr_from)
          get_instr = reaper.TrackFX_GetInstrument(tr_from) 
          retval, midi = reaper.TrackFX_GetFXName(tr_from, i, 0)
          if i~=get_instr and midi ~= 'VST: ReaControlMIDI (Cockos)' and midi ~= 'VST3: Melodyne (Celemony)' then
    
          fx_guid = reaper.TrackFX_GetFXGUID(tr_from, i)
          if fx_guid then
    
          fx_chain_from = chunk_from:match'<.-<(.*)>.->'
    
          fx_data_from = fx_chain_from:match('.*\n(BYPASS.-'..esc_lite(fx_guid)..'.-WAK.-\n)')
          fx_data_from = New_guids(fx_data_from)
    
    
    
          if tr_to == tr_from then chunk_to = chunk_from
            else chunk_to = GetTrackChunk(tr_to) end
    
          is_fx_chain = chunk_to:match('\n<FXCHAIN')
         if is_fx_chain then
    
          tr_chunk_no_64 = chunk_to
            for x in chunk_to:gmatch('\nBYPASS %d+ %d+ %d+\n<.-\n(.-)>') do
              tr_chunk_no_64 = tr_chunk_no_64:gsub(esc(x), '')
            end
    
           fx = reaper.TrackFX_GetCount(tr_to)
          if fx ~= 0 then
            before, after = tr_chunk_no_64:match('(.*\nWAK.-\n)(.*)')
          else before, after = tr_chunk_no_64:match('(.*\nDOCKED.-\n)(.*)')
          end
        else
          fx_chain_start = chunk_from:match'\n(<FXCHAIN\nSHOW .-DOCKED .-\n)'
          before, after = chunk_to:match('(.*\nMAINSEND.-\n)(.*)')
          before = before..fx_chain_start
          after = after..'>\n'
        end
    
          new_chunk_to = before..fx_data_from..after
    
          SetTrackChunk(tr_to, new_chunk_to)
    
        end
        end
      end
    end
 end




----------------------------------------------------------------------------------------------------


function select_tracks_with_selected_items()  
  reaper.Undo_BeginBlock()
  local get_first_track = reaper.GetTrack(0, 0)
  reaper.SetOnlyTrackSelected(get_first_track)
  reaper.SetTrackSelected(get_first_track, 0)
  local count_selected_med_items = reaper.CountSelectedMediaItems(0)
  for i = 0, count_selected_med_items-1  do
    local get_select_item = reaper.GetSelectedMediaItem(0, i)
    local get_select_track = reaper.GetMediaItem_Track(get_select_item)
    reaper.SetTrackSelected(get_select_track, 1)     
  end 
end




local function Main()

 --::START::
 
--local retval, value = reaper.GetUserInputs("Bounce selection", 11, "Set tail (sec)... ,Mono-1 Stereo-2 Multichan-3,Pre_fader-0  Post_fader-1,Time selection?  (1 - yes, 0 - no),Mute track1 item-2 Disab-3 Del-4,Include FX?  (1 - yes, 0 - no),    Copy FX? (when no include),    Copy FX envelopes lanes?,Include sends?  (1 - yes, 0 - no),Pre-render length (sec)...,    Trim item's start? (pre-rend)", values_for_render)

    --if retval then
     local val1, val4, val6, val5, val2, val3, val7, val9, val8, val10, val11 = values_for_render:match("([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+),([^,]+)")
     
     local val_tail = tonumber(val1)
     local val_mute = tonumber(val2)
     local val_fx = tonumber(val3)
     local val_render = tonumber(val4)
     local val_timesel = tonumber(val5)
     local val_fader = tonumber(val6)
     local val_fx_copy = tonumber(val7)
     local val_routing = tonumber(val8)
     local val_envelopes = tonumber(val9)
     local val_pre = tonumber(val10)
     local val_trim = tonumber(val11)

     if not val_tail or not val_mute or not val_fx or not val_render or not val_timesel or not val_fader or not val_fx_copy or not val_routing or not val_envelopes or not val_pre or not val_trim then 
     reaper.MB('No value. Please enter a number', 'Error', 0) end
     
     ---if not value for render, script must return---
     if val_render == 0 then return end 
     
     ---for playing project in real time :)---
     reaper.Main_OnCommand(1016, 0) reaper.Main_OnCommand(40345, 0)
     
     
    
    reaper.Main_OnCommand(41559, 0) -- solo items
    
    
    select_tracks_with_selected_items() 
    
    
    if val_fx == 0 then
       SetStrState() 
       SetFXState_save(false)
     end
     
          
      local save_start, save_end = reaper.GetSet_LoopTimeRange(0, false, 0, 0, 0)  
      local save_cursor_position = reaper.GetCursorPosition()
     
      if val_timesel == 0 then
        reaper.Main_OnCommand(40290, 0) -- Set time selection to items
      elseif val_timesel > 0 and save_start == save_end then
        reaper.Main_OnCommand(40290, 0) -- Set time selection to items
      end
      
      local selection_start, selection_end = reaper.GetSet_LoopTimeRange(0, false, 0, 0, 0)  
      reaper.GetSet_LoopTimeRange(1, false, selection_start-val_pre, selection_end+val_tail, 0)
      
      
      ---Count tracks before render----
      local count_tracks_1 = reaper.CountTracks(0)
      
      
     --if val_mute == 2 then reaper.Main_OnCommand(41312, 0) end
      
       
     if val_render == 2 then
           if val_fader > 0 then
             reaper.Main_OnCommand(41716, 0) -- stereo post fader
           elseif val_fader == 0 then
             reaper.Main_OnCommand(41719, 0) -- stereo pre fader
           end
         elseif val_render == 1 then
           if val_fader > 0 then
             reaper.Main_OnCommand(41718, 0) -- mono post fader
           elseif val_fader == 0 then
             reaper.Main_OnCommand(41721, 0) -- mono pre fader
           end
         elseif val_render >= 3 then
           if val_fader > 0 then
             reaper.Main_OnCommand(41717, 0) -- multichan post fader
           elseif  val_fader == 0 then
             reaper.Main_OnCommand(41720, 0) -- multichan pre fader
           end
      end
      
      
      
      ---Count tracks after render----
      local count_tracks_2 = reaper.CountTracks(0)
        
          
      
  if val_fx == 0 then
       local t = GetStrState()
     if count_tracks_1 ~= count_tracks_2 then
       SetFXState_restore(true, t)
     else
       SetFXState_restore_2(true, t)
     end
  end
  
  
  if val_trim > 0 and val_pre > 0 then
        local count_selected_tra = reaper.CountSelectedTracks(0)
              for i=0, count_selected_tra-1 do
                 local get_selected_track_ren = reaper.GetSelectedTrack(0,i)
                 local get_sel_it = reaper.GetTrackMediaItem(get_selected_track_ren, 0)
                 reaper.SplitMediaItem(get_sel_it, selection_start)
                 local get_sel = reaper.GetTrackMediaItem(get_selected_track_ren, 0)
                 reaper.DeleteTrackMediaItem(get_selected_track_ren, get_sel)
               end
           end
  
  
     ---Copy FX from original tracks from new track (without instruments and ReaControlMIDI)---
  if val_fx_copy > 0 and val_fx == 0 and val_envelopes > 0 then
    if count_tracks_1 ~= count_tracks_2 then -- If render is not canceled!
          
      ----------------------------------------------------------
          copy_fx_with_automations()
      ----------------------------------------------------------   
        
          
          for i=0, reaper.CountSelectedTracks(0)-1 do
            local get_track = reaper.GetSelectedTrack(0,i)
            local new_item = reaper.GetTrackMediaItem(get_track, 0)
            local new_item_start = reaper.GetMediaItemInfo_Value(new_item, 'D_POSITION')
            local new_item_length = reaper.GetMediaItemInfo_Value(new_item, 'D_LENGTH')
            local new_item_end = new_item_start + new_item_length
            local count_envelopes = reaper.CountTrackEnvelopes(get_track)
            for j=0, count_envelopes-1 do
              local get_envelope = reaper.GetTrackEnvelope(get_track, j)
              local count_points = reaper.CountEnvelopePoints(get_envelope) 
              local _, point_value_start, _, _, _ = reaper.Envelope_Evaluate(get_envelope, new_item_start, 0, 0)
              local _, point_value_end, _, _, _ = reaper.Envelope_Evaluate(get_envelope, selection_end+val_tail-0.00000000000001, 0, 0)
              local _, gxz, value, shape, tension, selected = reaper.GetEnvelopePoint(get_envelope, count_points-1)
              if count_points ~= 0 then
                for h=0, count_points-1 do
                  reaper.DeleteEnvelopePointRange(get_envelope, 0, new_item_start)
                  reaper.DeleteEnvelopePointRange(get_envelope, selection_end+val_tail, gxz+0.0000000001)
                end
              end
              reaper.InsertEnvelopePoint(get_envelope, new_item_start-0.000000000001, point_value_start, 0, 0, 0, 0)
              reaper.InsertEnvelopePoint(get_envelope, new_item_end, point_value_end, 0, 0, 0, 0)
            end  
          end
    end
  end
     
     
     
      
      if val_fx_copy > 0 and val_fx == 0 and val_envelopes == 0 then
          ---Copy FX from original tracks to new track (without instruments and ReaControlMIDI)---
          if count_tracks_1 ~= count_tracks_2 then -- If render is not canceled!
              local count_selected_tracks_fx = reaper.CountSelectedTracks(0)
              for i=0, count_selected_tracks_fx-1 do
                    local get_selected_track_fx = reaper.GetSelectedTrack(0,i)
                    local get_number_track_fx = reaper.GetMediaTrackInfo_Value(get_selected_track_fx,"IP_TRACKNUMBER")
                    local get_next_track_fx = reaper.GetTrack(0, get_number_track_fx)
                    local count_track_fx_copy = reaper.TrackFX_GetCount(get_next_track_fx)
                    local get_instrument_copy = reaper.TrackFX_GetInstrument(get_next_track_fx)
                    for j=0, count_track_fx_copy-1 do
                      local retval, midi = reaper.TrackFX_GetFXName(get_next_track_fx, j, 0)
                      if j ~= get_instrument_copy and midi ~= 'VST: ReaControlMIDI (Cockos)' and midi ~= 'VST3: Melodyne (Celemony)' then
                        reaper.TrackFX_CopyToTrack( get_next_track_fx, j, get_selected_track_fx, count_track_fx_copy, false)
                      end
                    end
              end
          end
      end
    
         
      if val_routing == 0 then
        if count_tracks_1 ~= count_tracks_2 then
         local count_selected_tracks_send = reaper.CountSelectedTracks(0)
         for i=0, count_selected_tracks_send-1 do
           local get_selected_track_send = reaper.GetSelectedTrack(0,i)
           local count_sends = reaper.GetTrackNumSends(get_selected_track_send, 0)
           if count_sends > 0 then
            for h=count_sends, 0, -1 do
              reaper.RemoveTrackSend(get_selected_track_send, 0, h)
            end
              reaper.SetMediaTrackInfo_Value(get_selected_track_send, 'B_MAINSEND', 1)
           end
         end
        end
      end
    
    ---Unmute original tracks, when is no mute option---
           if val_mute == 0 then
             if count_tracks_1 ~= count_tracks_2 then -- If render is not canceled!
               local count_selected_tracks = reaper.CountSelectedTracks(0)
               for i=0, count_selected_tracks-1 do
                 local get_selected_track_render = reaper.GetSelectedTrack(0,i)
                 local get_number_track = reaper.GetMediaTrackInfo_Value(get_selected_track_render,"IP_TRACKNUMBER")
                 local get_next_track = reaper.GetTrack(0, get_number_track)
                 if get_next_track then
                  reaper.SetMediaTrackInfo_Value(get_next_track, 'B_MUTE', 0) 
                 end
               end
             end
           elseif val_mute == 2 then
             if count_tracks_1 ~= count_tracks_2 then -- If render is not canceled!
                local count_selected_tracks = reaper.CountSelectedTracks(0)
                for i=0, count_selected_tracks-1 do
                  local get_selected_track_render = reaper.GetSelectedTrack(0,i)
                  local get_number_track = reaper.GetMediaTrackInfo_Value(get_selected_track_render,"IP_TRACKNUMBER")
                  local get_next_track = reaper.GetTrack(0, get_number_track)
                   if get_next_track then
                     reaper.SetMediaTrackInfo_Value(get_next_track, 'B_MUTE', 0) 
                   end
                end
            reaper.Main_OnCommand(40719, 0) -- mute item
            end
            reaper.Main_OnCommand(41560, 0) -- unsolo items
           elseif val_mute == 3 then
             if count_tracks_1 ~= count_tracks_2 then -- If render is not canceled!
               local count_selected_tracks = reaper.CountSelectedTracks(0)
                for i=0, count_selected_tracks-1 do
                  local get_selected_track_render = reaper.GetSelectedTrack(0,i)
                  local get_number_track = reaper.GetMediaTrackInfo_Value(get_selected_track_render,"IP_TRACKNUMBER")
                  local get_next_track = reaper.GetTrack(0, get_number_track)
                  if get_next_track then
                    for j=0, reaper.TrackFX_GetCount(get_next_track)-1 do
                      reaper.TrackFX_SetOffline(get_next_track, j, 1)
                    end
                    if reaper.CountTrackMediaItems(get_next_track) ~= 0 then
                      for g=0, reaper.CountTrackMediaItems(get_next_track)-1 do
                        local get_mute_item = reaper.GetTrackMediaItem(get_next_track, g)
                        reaper.SetMediaItemInfo_Value(get_mute_item, 'C_LOCK', 1)
                      end
                    end
                  end
                end
              end
            elseif val_mute >= 4 then
                     if count_tracks_1 ~= count_tracks_2 then -- If render is not canceled!
                       local count_selected_tracks = reaper.CountSelectedTracks(0)
                         for i=0, count_selected_tracks-2 do
                           local get_selected_track_render = reaper.GetSelectedTrack(0,i)
                           local get_number_track = reaper.GetMediaTrackInfo_Value(get_selected_track_render,"IP_TRACKNUMBER")
                           local get_next_track = reaper.GetTrack(0, get_number_track)
                           if get_next_track then
                             reaper.DeleteTrack(get_next_track)
                           end
                         end
                         local last_sel_track = reaper.GetSelectedTrack(0,count_selected_tracks-1)
                         local last_track_num = reaper.GetMediaTrackInfo_Value(last_sel_track,"IP_TRACKNUMBER")
                         local last_track = reaper.GetTrack(0, last_track_num)
                         local folder_next_track = reaper.GetMediaTrackInfo_Value(last_track, 'I_FOLDERDEPTH')
                         if folder_next_track <= -1 then
                           reaper.SetMediaTrackInfo_Value(last_sel_track, 'I_FOLDERDEPTH', folder_next_track)
                         end
                         reaper.DeleteTrack(last_track)
                       end
                     end
 
  if val_mute ~= 2 then
    reaper.Main_OnCommand(41560, 0) -- unsolo items
  end
  
  if count_tracks_1 ~= count_tracks_2 then
    reaper.Main_OnCommand(40421, 0) -- select all items in track
  end
  
  
  
  reaper.GetSet_LoopTimeRange(1, false, save_start, save_end, 0)   
  reaper.SetEditCurPos(save_cursor_position, 0, 0)  
  
  --else return end 
end





----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----

reaper.Undo_BeginBlock(1)
reaper.PreventUIRefresh(1)


Main()


reaper.UpdateArrange()
reaper.Undo_EndBlock('Bounce selection', -1)
reaper.PreventUIRefresh(-1)
