
if reaper.CountSelectedMediaItems(0) == 0 then reaper.MB('Please select an item', 'Error', 0) end


-----Thanks MPL-----Various functions for save/restore bypass state of FX----

local function SetStrState()
    local str = ''
    for i = 1, reaper.CountTracks(0) do
      local tr = reaper.GetTrack(0,i-1)
      str = str..'bypass_states '..reaper.GetTrackGUID(tr)
      for fx = 1,  reaper.TrackFX_GetCount( tr ) do
        local state = reaper.TrackFX_GetEnabled( tr, fx-1 )
        if state == false then 
          str = str..' '..(fx-1)
        end
      end
      str = str ..'\n'
    end
    reaper.SetProjExtState( 0, 'MPL_BYPASSFX', 'state', str )
  end

local function GetStrState()
    local t = {}
    local retval, str = reaper.GetProjExtState( 0, 'MPL_BYPASSFX', 'state' )
    if retval ~= 1 or str == '' then return end
    for line in str:gmatch('[^\r\n]+') do 
      if line:match('bypass_states') then 
        local GUID = line:match('%{.-%}')
        if GUID then 
          t[GUID]= {}
          for dig in line:gmatch('%s[%d]+') do if tonumber(dig) then  t[GUID][tonumber(dig)+1] = 1 end end
        end
      end 
    end
    return t
  end

local function IsInstrument(track, fx)  return  reaper.TrackFX_GetInstrument( track ) == fx end

---Save FX bypass for selected tracks----





local function SetFXState_save(FX_state, t)
    local count_items = reaper.CountSelectedMediaItems(0)
    for j=0, count_items-1 do
    local get_item = reaper.GetSelectedMediaItem(0,j)
    local track_get = reaper.GetMediaItemTrack(get_item)
    --for i = 1, reaper.CountSelectedTracks(0) do
      --local tr = reaper.GetSelectedTrack(0,i-1)
      local GUID = reaper.GetTrackGUID(track_get)
      for fx_id = 1, reaper.TrackFX_GetCount(track_get) do
        local retval, midi = reaper.TrackFX_GetFXName(track_get, fx_id-1, 0)
        if not IsInstrument(track_get, fx_id-1) and midi ~= 'VST: ReaControlMIDI (Cockos)' and midi ~= 'VST3: Melodyne (Celemony)' then
          -- check t
          if FX_state == true then 
            if not (t[GUID] and t[GUID][fx_id]) then
              reaper.TrackFX_SetEnabled(track_get, fx_id-1, FX_state)
            end
           else 
            reaper.TrackFX_SetEnabled(track_get, fx_id-1, FX_state)
          end
        end
      end
    end
  end

---Restore FX bypass for selected tracks---

local function SetFXState_restore(FX_state, t)
    local count_items = reaper.CountSelectedMediaItems(0)
    for j=0, count_items-1 do
    local get_item = reaper.GetSelectedMediaItem(0,j)
    local track_get = reaper.GetMediaItemTrack(get_item)
    --for i = 1, reaper.CountSelectedTracks(0) do
      --local tr = reaper.GetSelectedTrack(0,i-1)
      local GUID = reaper.GetTrackGUID(track_get)
      for fx_id = 1, reaper.TrackFX_GetCount(track_get) do
        local retval, midi = reaper.TrackFX_GetFXName(track_get, fx_id-1, 0)
        if not IsInstrument(track_get, fx_id-1) and midi ~= 'VST: ReaControlMIDI (Cockos)' and midi ~= 'VST3: Melodyne (Celemony)' then
          -- check t
          if FX_state == true then 
            if not (t[GUID] and t[GUID][fx_id]) then
              reaper.TrackFX_SetEnabled(track_get, fx_id-1, FX_state)
            end
           else 
            reaper.TrackFX_SetEnabled(track_get, fx_id-1, FX_state)
          end
        end
      end
    end
end




----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----RUN----

if reaper.CountSelectedMediaItems(0) == 0 then return end

::START::
local retval, value = reaper.GetUserInputs("Render to new take", 2, "Mono-1 Stereo-2 Multichan-3,Set offline the instrument?", "2,0")
if retval then 
  reaper.Undo_BeginBlock(1)
  reaper.PreventUIRefresh(1)
  
  local val2, val3 = value:match("([^,]+),([^,]+)")
  
  local val_render = tonumber(val2)
  local val_offline = tonumber(val3)

  
  if not val_render or not val_offline then
  reaper.MB('No value. Please enter a number', 'Error', 0) goto START end
  
  
  if val_render == 0 then return end

  ---for playing project in real time :)---
  reaper.Main_OnCommand(1016, 0) reaper.Main_OnCommand(40345, 0)
  --Select_tracks_with_items()
  
  --save bypass fx---
  SetStrState() 
  SetFXState_save(false)
  
  
  
  ---Render---
  if val_render == 2 then 
    reaper.Main_OnCommand(40209, 0) -- apply take stereo
  elseif val_render == 1 then
    reaper.Main_OnCommand(40361, 0) -- apply take mono
  elseif val_render >= 3 then
    reaper.Main_OnCommand(41993, 0) -- apply take mono
  end
  
  

  --restore bypass fx---
  local t = GetStrState()
  SetFXState_restore(true, t)

  if val_offline > 0 then
        local count_items = reaper.CountSelectedMediaItems(0)
        for i=0, count_items-1 do
          local get_item = reaper.GetSelectedMediaItem(0, i)
          local get_track = reaper.GetMediaItemTrack(get_item)
          local get_instrument = reaper.TrackFX_GetInstrument(get_track)
          reaper.TrackFX_SetOffline(get_track, get_instrument, 1)
          local count_fx = reaper.TrackFX_GetCount(get_track)
          for j=0, count_fx-1 do
            local retval, midi = reaper.TrackFX_GetFXName(get_track, j, 0)
            if midi == 'VST: ReaControlMIDI (Cockos)' then
              reaper.TrackFX_SetOffline(get_track, j, 1)
            end
          end
        end
  end
else return end
 
  
reaper.PreventUIRefresh(-1)
reaper.Undo_EndBlock('Apply to take (mono or stereo or multichannel)',-1)
